;-------------------------------------------------- --- --- -- -- - -
;---  eXo Paint v1.0 Main script
;-------------------------------------------------- --- --- -- -- - -
;---  See exp-read.txt for more information
;-------------------------------------------------- --- --- -- -- - -
;---  Released:  07-05-2001
;-------------------------------------------------- --- --- -- -- - -

;--- Aliases
alias exp {
  if ($window(@eXoPaint) != $null) {
    echo $colour(notice) -at *** eXo Paint Error:  Sorry, you can only have one eXo Paint session open at once!
    halt
  }
  window -dpk0 +nft @eXoPaint 20 20 500 400 @eXoPaint

  ;Set up window
  drawrect -f @eXoPaint 0 1 0 0 500 400

  ;Border Across
  drawline -r @eXoPaint $rgb(face) 2 39 40 500 40
  drawline -r @eXoPaint $rgb(shadow) 1 40 41 495 41
  drawline -r @eXoPaint $calc($rgb(frame) + 1) 1 41 42 495 42

  ;Border Down
  drawline -r @eXoPaint $rgb(face) 2 40 39 40 400
  drawline -r @eXoPaint $rgb(shadow) 1 41 41 41 375
  drawline -r @eXoPaint $calc($rgb(frame) + 1) 1 42 42 42 375

  ;Border Fill
  drawfill -r @eXoPaint $rgb(face) $rgb(face) 1 1

  ;Extra Borders
  drawline -r @eXoPaint $rgb(shadow) 1 0 267 41 267
  drawline -r @eXoPaint $rgb(hilight) 1 0 268 41 268
  drawline -r @eXoPaint $rgb(shadow) 1 0 324 41 324
  drawline -r @eXoPaint $rgb(hilight) 1 0 325 41 325

  ;Colors
  exp.drawcolbtns
  %exp.col = 1
  exp.drawcolbtns
  exp.drawpushbtn 66 4 15 15
  drawrect -f @eXoPaint 0 1 72 10 3 3

  ;Draw controls
  %exp.tl = dot
  %exp.fill = $false
  %exp.thk = 3
  exp.drawctrlbtns
  exp.drawpushbtn 5 5 30 30
  drawdot -r @eXoPaint $rgb(frame) 4 21 21

  ;Save button
  drawtext -ro @eXoPaint $rgb(text) "MS Sans Serif" -12 300 10 Save Picture

  ;Clear button
  drawtext -ro @eXoPaint $rgb(text) "MS Sans Serif" -12 430 10 Clear

  if ($1 != $null) {
    if ($1 == -cn) {
      titlebar @eXoPaint with $2
      %exp.con = $true
      drawtext -ro @eXoPaint $rgb(frame) "Arial" -36 102 150 eXo Paint v1.0
      drawtext -ro @eXoPaint $rgb(frame) "Arial" -14 147 223 Connecting, please wait...
    }
    elseif ($1 == -s) {
      %exp.con = $true
      drawtext -ro @eXoPaint $rgb(frame) "Arial" -36 102 150 eXo Paint v1.0
      drawtext -ro @eXoPaint $rgb(frame) "Arial" -14 85 223 Server started, waiting for connection...
      var %exp.tmp.port = $dialog(exp.serve,exp.serve,@eXoPaint)
      if (%exp.tmp.port == $null) {
        unset %exp.con
        exp.clear
        return
      }
      socklisten exopaintinits %exp.tmp.port
      titlebar @eXoPaint waiting for incoming connection on $ip $+ : $+ $sock(exopaintinits).port
    }
    elseif ($1 == -ip) {
      %exp.con = $true
      drawtext -ro @eXoPaint $rgb(frame) "Arial" -36 102 150 eXo Paint v1.0
      drawtext -ro @eXoPaint $rgb(frame) "Arial" -14 147 223 Connecting, please wait...
      var %exp.addy = $dialog(exp.connect,exp.connect,@eXoPaint)
      if (%exp.addy == $null) {
        unset %exp.con
        exp.clear
        return
      }
      sockopen exopaintrcvs $readini $scriptdir $+ exp-cfg.ini connect address $readini $scriptdir $+ exp-cfg.ini connect port
      titlebar @eXoPaint connecting to $readini $scriptdir $+ exp-cfg.ini connect address $+ : $+ $readini $scriptdir $+ exp-cfg.ini connect port
    }
    else {
      titlebar @eXoPaint with $1
      %exp.con = $true
      drawtext -ro @eXoPaint $rgb(frame) "Arial" -36 102 150 eXo Paint v1.0
      drawtext -ro @eXoPaint $rgb(frame) "Arial" -14 147 223 Connecting, please wait...
      socklisten exopaintinit
      .ctcp $1 EXP $ip $sock(exopaintinit).port
    }
  }
}

alias exp.draw {
  draw $+ $1-
  exp.out $1-
}

;Tool button outline aliases
alias exp.drawbtn {
  drawline -r @eXoPaint $rgb(hilight) 1 $1 $2 $calc($1 + $3 - 1) $2
  drawline -r @eXoPaint $rgb(hilight) 1 $1 $2 $1 $calc($2 + $4 - 1)
  drawline -r @eXoPaint $rgb(shadow) 1 $calc($1 + $3 - 1) $2 $calc($1 + $3 - 1) $calc($2 + $4)
  drawline -r @eXoPaint $rgb(shadow) 1 $1 $calc($2 + $4 - 1) $calc($1 + $3 - 1) $calc($2 + $4 - 1)
}
alias exp.drawpushbtn {
  drawline -r @eXoPaint $rgb(shadow) 1 $1 $2 $calc($1 + $3 - 1) $2
  drawline -r @eXoPaint $rgb(shadow) 1 $1 $2 $1 $calc($2 + $4 - 1)
  drawline -r @eXoPaint $rgb(hilight) 1 $calc($1 + $3 - 1) $2 $calc($1 + $3 - 1) $calc($2 + $4)
  drawline -r @eXoPaint $rgb(hilight) 1 $1 $calc($2 + $4 - 1) $calc($1 + $3 - 1) $calc($2 + $4 - 1)
}
alias exp.undrawbtn {
  drawline -r @eXoPaint $rgb(face) 1 $1 $2 $calc($1 + $3 - 1) $2
  drawline -r @eXoPaint $rgb(face) 1 $1 $2 $1 $calc($2 + $4 - 1)
  drawline -r @eXoPaint $rgb(face) 1 $calc($1 + $3 - 1) $2 $calc($1 + $3 - 1) $calc($2 + $4)
  drawline -r @eXoPaint $rgb(face) 1 $1 $calc($2 + $4 - 1) $calc($1 + $3 - 1) $calc($2 + $4 - 1)
}

alias exp.out {
  if ($sock(exopaint).ip != $null) {
    sockwrite -tn exopaint $1-
  }
}

;Draw colors on buttons
alias exp.drawcolbtns {
  exp.drawbtn 66 4 15 15
  exp.drawbtn 84 4 15 15
  exp.drawbtn 102 4 15 15
  exp.drawbtn 120 4 15 15
  exp.drawbtn 138 4 15 15
  exp.drawbtn 156 4 15 15
  exp.drawbtn 174 4 15 15
  exp.drawbtn 192 4 15 15
  exp.drawbtn 66 22 15 15
  exp.drawbtn 84 22 15 15
  exp.drawbtn 102 22 15 15
  exp.drawbtn 120 22 15 15
  exp.drawbtn 138 22 15 15
  exp.drawbtn 156 22 15 15
  exp.drawbtn 174 22 15 15
  exp.drawbtn 192 22 15 15
  drawrect -f @eXoPaint 1 1 68 6 11 11
  drawrect -f @eXoPaint 14 1 86 6 11 11
  drawrect -f @eXoPaint 5 1 104 6 11 11
  drawrect -f @eXoPaint 7 1 122 6 11 11
  drawrect -f @eXoPaint 3 1 140 6 11 11
  drawrect -f @eXoPaint 10 1 158 6 11 11
  drawrect -f @eXoPaint 2 1 176 6 11 11
  drawrect -f @eXoPaint 6 1 194 6 11 11
  drawrect -f @eXoPaint 0 1 68 24 11 11
  drawrect -f @eXoPaint 15 1 86 24 11 11
  drawrect -f @eXoPaint 4 1 104 24 11 11
  drawrect -f @eXoPaint 8 1 122 24 11 11
  drawrect -f @eXoPaint 9 1 140 24 11 11
  drawrect -f @eXoPaint 11 1 158 24 11 11
  drawrect -f @eXoPaint 12 1 176 24 11 11
  drawrect -f @eXoPaint 13 1 194 24 11 11
}

;Draw Control buttons
alias exp.drawctrlbtns {
  exp.undrawbtn 5 5 30 30
  drawdot -r @eXoPaint $rgb(shadow) 4 21 21
  exp.undrawbtn 5 38 30 30
  drawline -r @eXoPaint $rgb(shadow) 4 12 45 26 60
  exp.undrawbtn 5 71 30 30
  drawrect -r @eXoPaint $rgb(shadow) 2 12 78 16 16
  exp.undrawbtn 5 104 30 30
  drawrect -r @eXoPaint $rgb(shadow) 2 9 113 22 12
  exp.undrawbtn 5 137 30 30
  drawrect -re @eXoPaint $rgb(shadow) 2 12 144 16 16
  exp.undrawbtn 5 170 30 30
  drawrect -re @eXoPaint $rgb(shadow) 2 9 179 22 12
  exp.undrawbtn 5 203 30 30
  drawtext -ro @eXoPaint $rgb(shadow) "MS Sans Serif" -18 12 203 A
  exp.undrawbtn 5 236 30 30
  drawtext -ro @eXoPaint $rgb(shadow) "MS Sans Serif" -12 8 240 Fill
  if (%exp.tl isin squ rec cir ell) {
    if (%exp.fill == $true) {
      exp.undrawbtn 7 270 26 26
      drawrect -r @eXoPaint $rgb(shadow) 1 10 273 20 20
      exp.drawpushbtn 7 297 26 26
      drawrect -rf @eXoPaint $rgb(frame) 1 10 300 20 20
    }
    else {
      exp.drawpushbtn 7 270 26 26
      drawrect -r @eXoPaint $rgb(frame) 1 10 273 20 20
      exp.undrawbtn 7 297 26 26
      drawrect -rf @eXoPaint $rgb(shadow) 1 10 300 20 20
    }
  }
  else {
    exp.undrawbtn 7 270 26 26
    drawrect -r @eXoPaint $rgb(face) 1 10 273 20 20
    exp.undrawbtn 7 297 26 26
    drawrect -rf @eXoPaint $rgb(face) 0 10 300 20 20
  }
  if (%exp.tl isin dot line squ rect cir ell ers) {
    exp.drawthick
  }
  else {
    drawrect -rf @eXoPaint $rgb(face) 0 5 328 32 45
  }
}

alias exp.drawthick {
  if (%exp.thk == 1) { drawline -r @eXoPaint $rgb(frame) 1 6 330 35 330 }
  else { drawline -r @eXoPaint $rgb(shadow) 1 6 330 35 330 }
  if (%exp.thk == 2) { drawline -r @eXoPaint $rgb(frame) 2 6 336 34 336 }
  else { drawline -r @eXoPaint $rgb(shadow) 2 6 336 34 336 }
  if (%exp.thk == 3) { drawline -r @eXoPaint $rgb(frame) 3 7 342 33 342 }
  else { drawline -r @eXoPaint $rgb(shadow) 3 7 342 33 342 }
  if (%exp.thk == 4) { drawline -r @eXoPaint $rgb(frame) 4 7 350 33 350 }
  else { drawline -r @eXoPaint $rgb(shadow) 4 7 350 33 350 }
  if (%exp.thk == 5) { drawline -r @eXoPaint $rgb(frame) 5 8 358 32 358 }
  else { drawline -r @eXoPaint $rgb(shadow) 5 8 358 32 358 }
  if (%exp.thk == 6) { drawline -r @eXoPaint $rgb(frame) 6 8 368 32 368 }
  else { drawline -r @eXoPaint $rgb(shadow) 6 8 368 32 368 }
}

alias exp.clear {
  drawrect -f @eXoPaint 0 1 43 43 500 400
  exp.out clear -f @eXoPaint 0 1 43 43 500 400
}

alias exp.savepic {
  if ($readini $scriptdir $+ exp-cfg.ini save folder == $null) {
    var %exp.save.folder = $$sdir($mircdir,Select a folder to save in)
  }
  else {
    var %exp.save.folder = $$sdir($readini $scriptdir $+ exp-cfg.ini save folder,Select a folder to save in)
  }
  var %exp.save.file = $$?="Enter a filename to use:"
  if ($left(%exp.save.file,4) != .bmp) { %exp.save.file = %exp.save.file $+ .bmp }
  window -nph +ntf @eXoPaintSave 0 0 455 355
  drawcopy @eXoPaint 45 45 449 330 @eXoPaintSave 0 0
  drawsave @eXoPaintSave " $+ %exp.save.folder $+ %exp.save.file $+ "
  window -c @eXoPaintSave
  writeini exp-cfg.ini save folder %exp.save.folder
}

;--- Menus

menu @eXoPaint {
  mouse: { exp.mouse }
  sclick: { exp.sclick }
  uclick: { exp.uclick }
  drop: { exp.drophandle }
  Clear Image: exp.clear
  Save Image: exp.savepic
  -
  exp-read.txt: run " $+ $scriptdir $+ exp-read.txt $+ "
}

menu status,nicklist,query {
  Disegna
  .$iif($1 != $null,Paint with $1):exp $1
  .-
  .Disegna da solo:exp
  .$iif($server != $null,Disegna con qualcuno):exp $$?="Qual' il suo nickname?"
  .-
  .exp-read.txt: run " $+ $scriptdir $+ exp-read.txt $+ "
}

;--- Dialogs
dialog exp.text {
  title "eXo Paint - Text Tool"
  option dbu
  size -1 -1 150 60

  box "", 89, 2 0 146 58

  text "Text:", 12, 6 21 12 7, right
  edit "", 22, 19 19 125 11, autohs

  text "Size:", 11, 6 7 12 7, right
  combo 21, 20 6 20 120, drop edit

  text "Note: The text will be drawn in Times New Roman", 13, 5 32 140 7, center

  button "OK", 99, 33 42 40 12, ok default
  button "Cancel", 98, 77 42 40 12, cancel
}

on *:DIALOG:exp.text:init:*: {
  did -a $dname 21 6
  did -a $dname 21 8
  did -a $dname 21 10
  did -a $dname 21 12
  did -a $dname 21 14
  did -a $dname 21 16
  did -a $dname 21 18
  did -a $dname 21 20
  did -a $dname 21 24
  did -a $dname 21 30
  did -a $dname 21 32
  did -a $dname 21 36
  did -a $dname 21 40
  did -a $dname 21 48
  did -a $dname 21 72
  did -o $dname 21 0 12
}

on *:DIALOG:exp.text:sclick:99: {
  %exp.text.size = - $+ $did(21)
  %exp.text.text = $did(22)
  drawtext @eXoPaint %exp.col "Times New Roman" %exp.text.size %exp.text.x %exp.text.y %exp.text.text
  exp.out text @eXoPaint %exp.col "Times New Roman" %exp.text.size %exp.text.x %exp.text.y %exp.text.text
  unset %exp.text.*
}

on *:DIALOG:exp.text:sclick:98: {
  unset %exp.text.*
}

dialog exp.serve {
  title "eXo Paint - Start Server"
  option dbu
  size -1 -1 100 61

  box "", 81, 2 0 96 18
  text "Listen on port:", 11, 5 7 34 7
  edit "", 21, 40 5 34 11, result limit 5
  box "", 82, 2 14 96 29
  text "Connect to this address:", 12, 5 21 90 7, center
  edit "", 22, 5 28 90 11, center read

  button "Start Server", 99, 3 46 40 12, ok
  button "Cancel", 98, 57 46 40 12, cancel
}

on *:DIALOG:exp.serve:init:*: {
  if (($readini($scriptdir $+ exp-cfg.ini,server,port) != $null) && ($portfree($readini($scriptdir $+ exp-cfg.ini,server, port)))) {
    did -a $dname 21 $readini $scriptdir $+ exp-cfg.ini server port
    did -ra $dname 22 $ip $+ : $+ $did(21)
  }
  else {
    var %exp.temp.port
    while ($portfree(%exp.temp.port) != $true) {
      %exp.temp.port = $rand(1024,5000)
      did -a $dname 21 %exp.temp.port
      did -ra $dname 22 $ip $+ : $+ $did(21)
    }
  }
}

on *:DIALOG:exp.serve:edit:21: {
  if (($did(21) >= 1024) && ($did(21) <= 65000) && ($portfree($did(21)))) {
    did -ra $dname 22 $ip $+ : $+ $did(21)
  }
  elseif (($did(21) < 1024) || ($did(21) > 65000)) {
    did -ra $dname 22 Must be between 1024 and 65000
  }
  elseif ($portfree($did(21)) == $false) {
    did -ra $dname 22 Port in use. Try another.
  }
}

on *:DIALOG:exp.serve:sclick:99: {
  if (($did(21) < 1024) || ($did(21) > 65000)) {
    did -ra $dname 22 Must be between 1024 and 65000
    did -f $dname 21
    halt
  }
  elseif ($portfree($did(21)) == $false) {
    did -ra $dname 22 Port in use. Try another.
    did -f $dname 21
    halt
  }
  elseif (($did(21) >= 1024) && ($did(21) <= 65000) && ($portfree($did(21)))) {
    writeini $scriptdir $+ exp-cfg.ini server port $did(21)
  }
}

dialog exp.connect {
  title "eXo Paint - Connect to Server"
  option dbu
  size -1 -1 100 51

  box "", 81, 2 0 96 18
  text "Address:", 11, 5 7 21 7, right
  edit "", 21, 27 5 69 11, result
  box "", 82, 2 14 96 18
  text "Port:", 12, 5 20 21 7, right
  edit "", 22, 27 19 34 11, result limit 5

  button "Connect", 99, 3 36 40 12, ok
  button "Cancel", 98, 57 36 40 12, cancel
}

on *:DIALOG:exp.connect:init:*: {
  if ($readini $scriptdir $+ exp-cfg.ini connect address != $null) {
    did -a $dname 21 $readini $scriptdir $+ exp-cfg.ini connect address
  }
  if ($readini $scriptdir $+ exp-cfg.ini connect port != $null) {
    did -a $dname 22 $readini $scriptdir $+ exp-cfg.ini connect port
  }
}

on *:DIALOG:exp.connect:sclick:99: {
  if ($did(21) == $null) {
    beep 1 0
    did -f $dname 21
    halt
  }
  elseif ($did(22) == $null) {
    beep 1 0
    did -f $dname 22
    halt
  }
  writeini $scriptdir $+ exp-cfg.ini connect address $gettok($did(21),1,58)
  writeini $scriptdir $+ exp-cfg.ini connect port $did(22)
}

;--- Scripts
on *:LOAD: {
  if ($version < 5.91) {
    echo $colour(notice) *** eXo Paint was only tested on mIRC v5.91 and up.
    echo $colour(notice) *** It *should* work fine, but no promises.  If you have problems, try using mIRC v5.91
  }
  if ($exists($scriptdir $+ exp-hand.mrc) != $true) {
    echo $colour(ctcp) -at *** eXo Paint Error:  Could not load exp-hand.mrc!  eXo Paint will now be unloaded.
    unload -rs exp-main.mrc
    return
  }
  load -rs $scriptdir $+ exp-hand.mrc
  echo $colour(info2) -at *** eXo Paint is loaded and ready!  Just right-click in any window and pick eXo Paint to begin.
}

on *:START: {
  if ($script(exp-hand.mrc) == $null) {
    load -rs $scriptdir $+ exp-hand.mrc
    if ($script(exp-hand.mrc) == $null) {
      echo $colour(ctcp) -at *** eXo Paint Error:  Could not load exp-hand.mrc!  eXo Paint will now be unloaded.
      unload -rs exp-main.mrc
      return
    }
  }
}

on *:CLOSE:@eXoPaint*: {
  unset %exp.*
  exp.out exopaintquit
  sockclose exopaint*
}

;--- Connection / Socket stuff
ctcp *:EXP:?: {
  .timer 1 0 exp.doit $nick $address $$2 $$3
  haltdef
}
alias exp.doit {
  if ($$?!=" $+ $1 $+ $crlf $+ ( $+ $2 $+ ) $+ $crlf $+ $crlf $+ Wants to paint with you.") {
    sockopen exopaintrcv $$3 $$4
    exp -cn $1
  }
  else {
    .ctcpreply $1 EXP nothanks
  }
}

on *:CTCPREPLY:EXP*: {
  .timer 1 0 exp.alone $nick
  haltdef
}

alias exp.alone {
  if ($$?!=" $+ $1 has rejected your paint request. $+ $crlf $+ Do you want to paint alone?") {
    unset %exp.con
    exp.clear
    titlebar @eXoPaint
  }
  else {
    close -@ @eXoPaint
  }
}

on *:SOCKLISTEN:exopaintinit*: {
  if ($sockerr > 0) { close @eXoPaint | sockclose $sockname | halt }
  sockaccept exopaint
  sockclose $sockname
  .timerexpcon off
}

on *:SOCKOPEN:exopaintrcv*: {
  if ($sockerr > 0) {
    close -@ @eXoPaint
    echo $colour(notice) -at *** eXo Paint connection failed: $sock($sockname).wsmsg
    sockclose $sockname
    unset %exp.*
    halt
  }
  sockwrite -tn $sockname eXoPaintReady 1.0
  sockrename $sockname exopaint
  .timerexpcon off
}

on *:SOCKREAD:exopaint: {
  if ($sockerr > 0) { halt }
  var %exp.temp
  sockread %exp.temp
  tokenize 32 %exp.temp

  if ($1- === eXoPaintReady 1.0) {
    sockwrite -tn $sockname eXoPaintStart 1.0
    %exp.go = $true
    drawrect -f @eXoPaint 0 1 43 43 500 400
    unset %exp.con
    if ($gettok($window(@eXoPaint).title,1-5,32) == waiting for incoming connection on) {
      titlebar @eXoPaint connected to $sock($sockname).ip $+ : $+ $sock($sockname).port
    }
    elseif ($gettok($window(@eXoPaint).title,1-2,32) == connecting to) {
      titlebar @eXoPaint connected to $sock($sockname).ip $+ : $+ $sock($sockname).port
    }
  }
  elseif ($1- === eXoPaintStart 1.0) {
    %exp.go = $true
    drawrect -f @eXoPaint 0 1 43 43 500 400
    unset %exp.con
    if ($gettok($window(@eXoPaint).title,1-5,32) == waiting for incoming connection on) {
      titlebar @eXoPaint connected to $sock($sockname).ip $+ : $+ $sock($sockname).port
    }
    elseif ($gettok($window(@eXoPaint).title,1-2,32) == connecting to) {
      titlebar @eXoPaint connected to $sock($sockname).ip $+ : $+ $sock($sockname).port
    }
  }
  elseif (%exp.go) {
    if ($1 isin dot line) { drawline $2- }
    elseif ($1 isin squ rec cir ell) { drawrect $2- }
    elseif ($1 == fill) { drawfill $2- }
    elseif ($1 == text) { drawtext $2- }
    elseif (($1 == clear) && ($3 === @eXoPaint)) { drawrect -f @eXoPaint 0 1 43 43 500 400 }
  }
}

on *:SOCKCLOSE:exopaint*: {
  if ($gettok($window(@eXoPaint).title,1-2,32) == connected to) {
    titlebar @eXoPaint disconnected from $gettok($window(@eXoPaint).title,3,32)
  }
  else {
    titlebar @eXoPaint disconnected from $gettok($window(@eXoPaint).title,2,32)
  }
  .timerexpcon off
}
